#! /usr/bin/python

# Script used to create the template.html file
# To run simply do
#
# ./create_template.py


import sys, zlib, struct

bigfont = """<font face="verdana" size="2">"""
font = """<font face="verdana" size="1">"""
colors = [ "CCCCEE", "FFFF96", "40C880", "80A0FF", "9696FF", 
           "CCCCEE", "CCCCEE", "CCCCEE" ]

imagenames = [ "beforegzip", "aftergzip", "beforecache", "aftercache" ]

titlenames = ["Without<br>gzip", "With<br>gzip", \
             "Without<br>cache", "With<br>cache",
             "Total", "Gzipped", "Cached" ]

datanames = [ "beforegzip", "aftergzip", "beforecache", "aftercache",
              "total_count", "gzipped_count", "cached_count" ]

daynames = [ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ]


def replace_font_and_color(s):
    s = s.replace("$font$", font)
    s = s.replace("$bigfont$", bigfont)
    for i in range(0, 8):
        s = s.replace("$color" + str(i) + "$", colors[i])
    return s


f = open("template.html", "w")

s = """
<html>
<head><title>Vicompress Log Statistics</title></head>
<body>
$bigfont$
<p>
<img src="visolvelogo.gif"></img>
<p>
<b>Vicompress Log Statistics</b>
<p>
Report for month: <b> $monthname$ $year$ </b><br>
<a href="statsindex.html">View other dates</a>
<p>
<hr>
<p>

<table bordercolor=#$color0$ cellspacing=0 cellpadding=2 border=2>
  <tr bgcolor="#$color0$">
    <td>
      <b>$bigfont$ Monthly bandwidth</font></b>
    </td>
  </tr>
  <tr>
    <td align="center" valign="bottom" colspan=4>
"""

s = replace_font_and_color(s)
f.write(s)

i = 1 
for name in imagenames:
    s = "<img title=\"$month_%s$\" alt=\"$month_%s$\" height=$month_%s_height$ width=8 src=\"verticalbar%d.png\"/>" % (name, name, name, i)
    f.write(s)
    i += 1

f.write("""
    </td>
""")

s = """
  </tr>
  <tr>
    <td>
      <table bgcolor="#FFFFFF" cellpadding=4 cellspacing=2 border=0>
        <tr>
          <td bgcolor=#$color0$ align="center" colspan=4>
            $font$ <b>Bandwidth </b></font>
          </td>
          <td bgcolor=#$color0$ align="center" colspan=3>
            $font$ <b>Requests </b></font>
          </td>
        </tr>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

i = 1
for name in titlenames:
    s = """          <td bgcolor=#$color%d$ align="center" nowrap>$font$<b>%s</b></font></td>\n""" % (i, name)
    s = replace_font_and_color(s)
    f.write(s)
    i += 1

f.write("""        </tr>\n""")
f.write("""        <tr>\n""")

for name in datanames:
    s = """          <td align="right" nowrap>$font$ $month_%s$ </font></td>\n """ % (name)
    s = replace_font_and_color(s)
    f.write(s)


s = """
        </tr>
      </table>
    </td>
  </tr>
</table>

<p>

<table bordercolor=#$color0$ cellspacing=0 cellpadding=2 border=2>
  <tr bgcolor="#$color0$">
    <td>
      <b>$bigfont$ Weekly bandwidth</font></b>
    </td>
  </tr>
  <tr>
    <td>
      <table border=0 cellspacing=2 cellpadding=2>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

for day in range(1,8):
    s = """          <td nowrap valign="bottom">"""
    f.write(s)
    i = 1
    for name in imagenames:
        s = """<img title="$dayweek_%s%d$" alt="$dayweek_%s%d$" height=$dayweek_%s_height%d$ width=8 src="verticalbar%d.png"/>""" % (name, day, name, day, name, day, i)
        f.write(s)
        i += 1
    f.write("          </td>\n")

s = """
        </tr>
        <tr>
"""

f.write(s)

for name in daynames:
    s = """          <td align="center">$font$<b> %s </b></font></td>\n""" % (name)
    s = replace_font_and_color(s)
    f.write(s)

s = """
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td>
      <table border=0 cellpadding=4 cellspacing=2>
        <tr>
          <td align="center" bgcolor="#$color0$" colspan=5>
           $font$ <b>Bandwidth</b></font>
          </td>
          <td align="center" bgcolor="#$color0$" colspan=3>
            $font$ <b>Requests</b></font>
          </td>
        </tr>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

i = 0
names = [ "Day" ] + titlenames
for name in names:
    s = """          <td align="center" bgcolor="#$color%d$">$font$ <b> %s</b> </font></td>\n""" % (i, name)
    s = replace_font_and_color(s)
    f.write(s)
    i += 1

f.write("        </tr")

i = 1
for day in daynames:
    f.write("""        <tr>\n""")
    s = """          <td>$font$ %s </font></td>\n""" % (day)
    s = replace_font_and_color(s)
    f.write(s)
    for name in datanames:
        s = """          <td align="right" nowrap>$font$ $dayweek_%s%d$ </font></td>\n""" % (name, i)
        s = replace_font_and_color(s)
        f.write(s)
    f.write("""        </tr>\n""")
    i += 1

s = """
      </table>
    </td>
  </tr>
</table>

<p>

<table bordercolor=#$color0$ cellspacing=0 cellpadding=2 border=2>
  <tr bgcolor="#$color0$">
    <td colspan=2>
      <b>$bigfont$ Daily bandwidth</font></b>
    </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" colspan=2>
      <table border=0 cellspacing=2 cellpadding=2>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

for day in range(1,32):
    f.write("""          <td nowrap valign="bottom">""")
    i = 1
    for name in imagenames:
        s = """<img title="$day_%s%d$" alt="$day_%s%d$" height=$day_%s_height%d$ width=5 src="verticalbar%d.png"/>""" % (name, day, name, day, name, day, i)
        f.write(s)
        i += 1
    f.write("""          </td>\n""")

f.write("""        </tr>\n""")
f.write("""        <tr>\n""")

for day in range(1,32):
    s = """          <td align="center">$font$<b> %d </b></font></td>\n""" % (day)
    s = replace_font_and_color(s)
    f.write(s)

s = """
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td valign="top">
      <table border=0 cellpadding=4 cellspacing=2>
        <tr>
          <td align="center" bgcolor="#$color0$" colspan=5>
            $font$ <b>Bandwidth</b></font>
          </td>
          <td align="center" bgcolor="#$color0$" colspan=3>
            $font$ <b>Requests</b></font>
          </td>
        </tr>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

i = 0
names = [ "Day" ] + titlenames
for name in names:
    s = """          <td align="center" bgcolor="#$color%d$">$font$<b>%s</b></font></td>\n""" % (i, name)
    s = replace_font_and_color(s)
    f.write(s)
    i += 1

f.write("""        </tr>\n""")

for day in range(1,32):
    f.write("""        <tr>\n""")
    s = """          <td>$font$ %d </font></td>\n""" % (day)
    s = replace_font_and_color(s)
    f.write(s)
    for name in datanames:
        s = """          <td align="right" nowrap>$font$ $day_%s%d$ </font></td>\n""" % (name, day)
        s = replace_font_and_color(s)
        f.write(s)
    f.write("""        </tr>\n""")


s = """
      </table>
    </td>
  </tr>
</table>

<p>

<table bordercolor=#$color0$ cellspacing=0 cellpadding=2 border=2>
  <tr bgcolor="#$color0$">
    <td colspan=2>
      <b>$bigfont$ Hourly bandwidth</font></b>
    </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" colspan=2>
      <table border=0 cellspacing=2 cellpadding=2>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

for h in range(0,24):
    f.write("""          <td nowrap valign="bottom">""")
    i = 1
    for name in imagenames:
        s = """<img title="$hour_%s%d$" alt="$hour_%s%d$" height=$hour_%s_height%d$ width=6 src="verticalbar%d.png"/>""" % (name, h, name, h, name, h, i)
        f.write(s)
        i += 1
    f.write("""</td>\n""")

f.write("""        </tr>\n""")
f.write("""        <tr>\n""")

for h in range(0,24):
    s = """          <td align="center">$font$<b> %d </b></font></td>\n""" % (h)
    s = replace_font_and_color(s)
    f.write(s)

s = """
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td valign="top">
      <table border=0 cellpadding=4 cellspacing=2>
        <tr>
          <td align="center" bgcolor="#$color0$" colspan=5>
            $font$ <b>Bandwidth</b></font>
          </td>
          <td align="center" bgcolor="#$color0$" colspan=3>
            $font$ <b>Requests</b></font>
          </td>
        </tr>
        <tr>
"""

s = replace_font_and_color(s)
f.write(s)

i = 0
names = [ "Hour" ] + titlenames
for name in names:
    s = """          <td align="center" bgcolor="#$color%d$">$font$<b>%s</b></font></td>\n""" % (i, name)
    s = replace_font_and_color(s)
    f.write(s)
    i += 1

f.write("""        </tr>\n""")

for h in range(0, 24):
    f.write("""        <tr>\n""")
    s = """          <td>$font$ %d </font></td>\n""" % (h)
    s = replace_font_and_color(s)
    f.write(s)

    for name in datanames:
        s = """          <td align="right" nowrap>$font$ $hour_%s%d$ </font></td>\n""" % (name, h)
        s = replace_font_and_color(s)
        f.write(s)

    f.write("""        </tr>\n""")

s = """
      </table>
    </td>
  </tr>
</table>

<p>
</body></html>
"""

f.write(s)



